HDU 1548 A strange lift

A strange lift

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 9108    Accepted Submission(s): 3453

Problem Description
There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can't go up high than N,and can't go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you'll go up to the 4 th floor,and if you press the button "DOWN", the lift can't do it, because it can't go down to the -2 th floor,as you know ,the -2 th floor isn't exist. Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
 
Input
The input consists of several test cases.,Each test case contains two lines. The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn. A single 0 indicate the end of the input.
 
Output
For each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can't reach floor B,printf "-1".
 
Sample Input
5 1 5
3 3 1 2 5
0
 
Sample Output
3
 
Recommend
8600
 
思路:BFS,然后各种WA,最重要的是标记数组必须开二维的;
因为从一个点向上和向下是不同的,必须分别标记
 
代码:
#include <iostream>
#include <cstring>
#include <cmath>
#include <queue>
#include <cstdio>
using namespace std;
struct Node
{
    int position;
    int step;
};
int s;
int hash[410][2];
int n,a,b;
int map[410];
void BFS()
{
    queue <Node> q;
    Node top;top.position = a;top.step = 0;
    q.push(top);
    while(!q.empty())
    {
        Node temp;temp = q.front();q.pop();
        if(temp.position == b)
        {
            s = temp.step;
            return ;
        }
        int x = temp.position;int stop = temp.step;
        if((x - map[x]) >= 1 && hash[x][0] == 0)
        {
            hash[x][0] = 1;
            Node xin;xin.position = x - map[x];xin.step = stop + 1;
            q.push(xin);
        }
        if((x + map[x]) <= n && hash[x][1] == 0)
        {
            hash[x][1] = 1;
            Node xin;xin.position = x + map[x];xin.step = stop + 1;
            q.push(xin);
        }
    }
}
int main()
{
    while(scanf("%d",&n),n != 0)
    {
        scanf("%d%d",&a,&b);
        memset(hash,0,sizeof(hash));
        memset(map,0,sizeof(map));
        for(int i = 1;i <= n;i ++)
           scanf("%d",&map[i]);
        s = 0;
        if(a == b)
            printf("0 ");
        else
        {
           if(map[a] != 0)
                    BFS();
           if(s == 0)
              s = -1;
           printf("%d ",s);
        }
    }
    return 0;
}
原文地址:https://www.cnblogs.com/GODLIKEING/p/3335926.html